#ifndef SLMOTION_BLACK_BOARD_EXCEPTION
#define SLMOTION_BLACK_BOARD_EXCEPTION

#include "exceptions.hpp"

namespace slmotion {
  /**
   * A very simple class used to signal exceptional events, e.g. when trying
   * to access an element that does not exist
   */
  class BlackBoardException : public SLMotionException {
  public:
    /**
     * Trivial constructor
     */
    explicit BlackBoardException(const char* msg) throw() :
      SLMotionException(msg) {}


    
    explicit BlackBoardException(const std::string& msg) throw() :
      SLMotionException(msg.c_str()) {}



    virtual ~BlackBoardException() throw() {}
  };
}
#endif
