#include "SkinDetector.hpp"

namespace slmotion {
  /**
   * A fake skin detector that just copies existing skin detections 
   * from blackboard
   */
  class CopySkinDetector : public SkinDetector {
  public:
    
    explicit CopySkinDetector(BlackBoard* blackBoard, 
                              FrameSource* frameSource,
                              const ColourSpace& c = *ColourSpace::RGB) :
      SkinDetector(blackBoard, frameSource, c) {}


    std::string findParameters(const cv::Mat&, const cv::Mat&, double = 1,
                               double = 1) {

      assert(false); // not implemented, this is here to catch attention
    }

  private:
    void detect(const cv::Mat& inFrame, cv::Mat& outMask);
  };
}
